// =====================================================================
/*!
//
//  \file TInputObjectFileOnline.hh
//  \brief This file contains the TInputObjectFileOnline class.
//  \author Go IWAI <goiwai@users.sourceforge.jp>
//
//  $Id: TInputObjectFileOnline.hh,v 1.6 2004/03/07 10:30:32 goiwai Exp $
//  $Name: CLDAQ-1-14-03 $
//  $Log: TInputObjectFileOnline.hh,v $
//  Revision 1.6  2004/03/07 10:30:32  goiwai
//  ROOTに組みこむためのおまじないマクロを埋めこみました。
//  全てにおいて完全に動作するわけではありません。
//
//  Revision 1.5  2004/01/19 21:09:41  goiwai
//  プリプロセッサの接頭辞をCLDAQ__に変更しました.
//
//  Revision 1.4  2003/12/06 10:56:19  goiwai
//  フィルタ関連の修整と Read(),Write()の戻り値の修整です.
//  Read()もWrite()も処理したレコードサイズを返します.
//  フィルタがある場合も同様です.
//  それぞれのストリームのDataSizeの扱いですが,これは扱ったレコードサイズ
//  でなく扱ったファイルやソケットなどのサイズになります.レコードサイズと
//  一致するとは限りません.
//
//  Revision 1.3  2003/11/03 08:35:13  goiwai
//  Doxygen用のタグとコメントをうちこんでいく試みを開始しました.
//
//  Revision 1.2  2003/10/14 22:05:35  goiwai
//  やたら落ちるのとCPU食いまくるので,usleep(100*1000)するようにしました.
//  やっぱレコードにステータス持たせないとだめですね.以下,提案：
//  8bit:	status
//  32bit:	total size
//
//  Revision 1.1  2003/10/12 13:01:47  goiwai
//  オンラインでファイルを見ることが多いのでオンライン用のものを用意しまし
//  た.1イベント読むことに成功するまで Read() メンバ関数から戻ってきません
//  ので,終了時には レコードID を見てループから抜ける必要があります.
//  データフォーマットにステータス持たせればこの必要はなかったんですが.
//
*/
// =====================================================================
#ifndef CLDAQ__TINPUTOBJECTFILEONLINE_HH
#define CLDAQ__TINPUTOBJECTFILEONLINE_HH

#include "Tglobals.h"
#include "TInputObjectFile.hh"

class TStreamableObject;
class TDataRecord;
class TDataSection;
class TDataSegment;
class TDataElement;
class TObjectFilter;
class TInputObjectFilter;


/*!
// \example
//
// If example code exists.
//
*/

/*!
// \class TInputObjectFileOnline
// \brief This is the TInputObjectFileOnline class.
// \author Go IWAI <goiwai@users.sourceforge.jp>
//
// The TInputObjectFileOnline class detail description.
// Write it down ASAP!
//
// \todo None?
// \bug None?
// \ingroup PersistencyCategory
*/
class TInputObjectFileOnline
  : public TInputObjectFile
{

  private:
    enum { DEFAULT = 10 * 1000 };  // 10ms

  private:
    Tint theMicroSleepTime;

  public:
    TInputObjectFileOnline( const Tstring& filename, const Tstring& mode = "r", Tint utime = DEFAULT );
    TInputObjectFileOnline( TInputObjectFilter* filter, const Tstring& filename, const Tstring& mode = "r", Tint utime = DEFAULT );
    ~TInputObjectFileOnline();

  public:
    Tint Read( TStreamableObject& object );

  public:
    Tint GetMicroSleepTime() const;
    Tvoid SetMicroSleepTime( Tint utime );
    Tbool IsSleep() const;
    Tvoid MicroSleep() const;

#ifdef __CLDAQ_ROOT_DLL
    ClassDef(TInputObjectFileOnline,0)
#endif

};

inline Tint TInputObjectFileOnline::GetMicroSleepTime() const
{
  return theMicroSleepTime;
}

inline Tvoid TInputObjectFileOnline::SetMicroSleepTime( Tint utime )
{
  theMicroSleepTime = utime;
  return;
}

inline Tbool TInputObjectFileOnline::IsSleep() const
{
  return ( theMicroSleepTime > 0 );
}

inline Tvoid TInputObjectFileOnline::MicroSleep() const
{
  if ( IsSleep() ) {
    usleep( theMicroSleepTime );
  }
  return;
}

#endif
